/*
    usbtmcsimple.h

    Copyright © 2014 thinwire

    This file is part of rigoltmc.

    rigoltmc is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    rigoltmc is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with rigoltmc.  If not, see <http://www.gnu.org/licenses/>.
*/


#include <libusb-1.0/libusb.h>

// Some defines for USBTMC

// The io-buffer size should be a multiple of 512
#define USBTMC_SIZE_IOBUFFER    4096
#define USBTMC_SIZE_HEADER      12
#define USBTMC_TIMEOUT          10
#define DEV_DEP_MSG_OUT         1
#define REQUEST_DEV_DEP_MSG_IN  2
#define USB_BULKOUT_ADDRESS     0x02
#define USB_BULKIN_ADDRESS      0x86
#define RIGOL_USB_VID           0x1ab1 // Rigol USB vendor ID
#define RIGOL_USB_DS1000_PID    0x0588 // Rigol DS1000 product ID
#define RIGOL_USB_DS2000_PID    0x04b0 // Rigol DS2000 product ID
#define RIGOL_USB_DS4000_PID    0x0641 // Rigol DS4000 product ID

extern libusb_device_handle *usbtmc_init(
          int verbose, 
          int vid,
          int pid);

extern int usbtmc_write(
          libusb_device_handle *dev_handle,
          int cmdsize,
          const char *cmd,
          unsigned char &bTag);

extern int usbtmc_read(
          libusb_device_handle *dev_handle,
          int &rsize,
          unsigned char *rdata,
          unsigned char &bTag);

extern void usbtmc_shutdown(
          libusb_device_handle *dev_handle);

